import numpy as np
import functools

# ---- Task (a) -------
# Do as directed in function:
# 'my_list': a list of 25 integers
def avada_kedavra(my_list):
	# Create an array 'a0' from this list 'my_list'
	a0 = np.array(my_list)
	# print a0
	print("a0 at beginning:\n{}".format(a0))

	# reshape a0 to create a 5X5 matrix a1
	a1=a0.reshape(5,5)
	# print a1
	print("a1 at the beginning:\n{}".format(a1))

	# now, change the central element of a1 to 0
	a1[2][2]=0
	# print a1
	print("a1 after change:\n{}".format(a1))

	# print a0
	print("a0 after changing a1:\n{}".format(a0))
	print("reshaping doesn't create a copy of array. It just returns another view. So, changing one changed the other")

	# make a copy of a1 and flatten it (call it a1cpy)
	a1cpy = a1.copy()
	a1=a1.cpy.flatten()
	# multiply each element of a1cpy by 0.7:
	a1=[element * 2 for element in a1]
	# print a1cpy:
	print("a1cpy\n{}".format(a1cpy))

	# print a1:
	print("a1 after changing its copy:\n{}".format(a1))


# ---- Task (b) -------
# Do as directed in function:
# 'my_integer': an even integer
def incendio(my_integer):
	# create an array 'arng0' of shape (3,2) containing consecutive even numbers starting from 'my_integer', arranged along rows
	arng0 = np.arange(start=my_integer, stop=my_integer + 11, step=2)
	arng0 = arng0.reshape(3, 2)
	# print arng0
	print("arng0\n{}".format(arng0))

	# create another array 'arng1' of shape ((4,3)) containing consecutive numbers starting from 'my_integer' arranged along columns:
	arng1 = np.arange(start=my_integer, stop=my_integer + 12, step=1)
	arng1 = np.reshape(arng1, (4, 3), order='F')
	# print arng1
	print("arng1\n{}".format(arng1))

	# multiply transpose of arng0 with transpose of arng1 to get mult0:
	mult0=np.dot(np.transpose(arng0),np.transpose(arng1))
	# print mult0:
	print("mult0\n{}".format(mult0))

	# take min of mult0 along its rows and store it in v0:
	v0=mult0.min(axis=1)
	# print v0's shape:
	print("shape of v0: \n{}".format(v0.shape))

	# reshape v0 to make it a column vector:
	v0=np.reshape(v0,(-1,1))
	# subtract v0 from each column of mult0 and store it in base0:
	base0=mult0-v0
	# print base0
	print("base0\n{}".format(base0))

	# square all the elements present in base0
	base0=np.power(base0,2)
	# store the sum of all elements of base0 in ans
	ans=sum(map(sum,base0))
	# print ans
	print("ans : {}".format(ans))


# ---- Task (c) -------
# 'n': integer
# 'm': integer that divides n
# return type: int numpy Ndarray; dim: nxn
def alohomora(n, m):
	arr = np.ones((n, n), dtype=int)
	list1 = [list(range(x, x + m)) for x in range(n) if x % m == 0 and (x // m) % 2 != 0]
	list2 = [list(range(x, x + m)) for x in range(n) if x % m == 0 and (x // m) % 2 == 0]
	indices_1 = functools.reduce(lambda t1, t2: t1 + t2, list1)
	indices_2 = functools.reduce(lambda t1, t2: t1 + t2, list2)
	arr[np.ix_(indices_1, indices_2)] = 0
	arr[np.ix_(indices_2, indices_1)] = 0
	return(arr)
	pass


# ---- Task (d) -------
# 'arr': float Ndarray; dim: Nx3,
# 'theta': float; 0≤theta<360 (in degrees)
# 'axis': str; axis ∈ {'X','Y','Z'}
# return type: float Ndarray; dim: Nx3
def expelliarmus(arr, theta, axis):
	if (axis == 'X'):
		theta = np.radians(360 - theta)
		c, s = np.cos(theta), np.sin(theta)
		R = [1, 0, 0, 0, c, -s, 0, s, c]
		R = np.array(R)
		R = R.reshape((3, 3))
		return np.round_(np.dot(arr, R), decimals=2)
	if (axis == 'Y'):
		theta = np.radians(360 - theta)
		c, s = np.cos(theta), np.sin(theta)
		R = [c, 0, s, 0, 1, 0, -s, 0, c]
		R = np.array(R)
		R = R.reshape((3, 3))
		return np.round_(np.dot(arr, R), decimals=2)
	if (axis == 'Z'):
		theta = np.radians(360 - theta)
		c, s = np.cos(theta), np.sin(theta)
		R = [c, -s, 0, s, c, 0, 0, 0, 1]
		R = np.array(R)
		R = R.reshape((3, 3))
		return np.round_(np.dot(arr, R), decimals=2)

	pass


# ---- Task (e) -------
# 'arr': float Ndarray; dim: MxN
# return type: float Ndarray; dim: MxN
def crucio(arr):
	m, n = np.shape(arr)
	arr = np.array(arr)
	mean_array = arr.mean(axis=0)
	means_expanded = np.outer(mean_array, np.ones(m))

	means_expanded = np.transpose(means_expanded)

	result = np.subtract(arr, means_expanded)
	std_array = np.std(arr, axis=0)
	SD_expanded = np.outer(std_array, np.ones(m))
	SD_expanded = np.transpose(SD_expanded)

	return np.round(np.divide(result, SD_expanded), decimals=2)
	pass


# ---- Task (f) -------
# 'arr': int 1-D array; dim: (n,)
# k: integer
# return type: int 1-D array; dim: (n+k-1,)
def leviosa(arr, k):
	arr_pad = np.pad(np.array(arr), (0, k - 1), 'constant')
	arr_cumsum = arr_pad.cumsum()
	arr_cumsum[k:] = arr_cumsum[k:] - arr_cumsum[:(k * -1)]
	return arr_cumsum
	pass


# ---- Task (g) -------
# 'mat': int n-D array; dim: (m,n)
# k: integer
# return type: n-D integer array; dim: (m,k)
def accio(mat, k):
	return np.argsort(mat, kind="mergesort", axis=1)[:, :-(k+1):-1]
