from stackapi import StackAPI
import csv

if __name__ == "__main__":
    SITE = StackAPI('stackoverflow')
    SITE.page_size = 50
    SITE.max_pages = 1
    inps = list(map(lambda x: x.lower(), input().split()))
    questions = SITE.fetch('search/advanced', accepted=True, tagged=";".join(inps), sort='votes')
    filename = "_".join(inps)
    fields = ['question_id', 'tag', 'link', 'tags', 'accepted_answer']
    items = questions["items"]
    with open(filename+".csv", 'w+') as csvfile:
        csvwriter = csv.writer(csvfile)
        csvwriter.writerow(fields)
        for item in items:
            row = [item["question_id"], filename, item["link"], str(item["tags"]),
                   item["link"] + "/#" + str(item["accepted_answer_id"])]
            csvwriter.writerow(row)
        csvfile.close()
