import argparse
import pandas as pd
import matplotlib.pyplot as plt

if __name__ == "__main__":
    ap = argparse.ArgumentParser()
    ap.add_argument("--data", required=True, help="Data file name")
    args = vars(ap.parse_args())
    data = pd.read_csv(args["data"])
    instance_group = data.groupby("instance")
    l = list(instance_group)
    for i in range(len(l)):
        in_group = l[i][1].groupby(by=["horizon", "epsilon", "algorithm"]).regret.mean()
        in_group = in_group.unstack(level=[-1, -2])
        plt.style.use("seaborn")
        in_group.plot(figsize=(12, 8), fontsize=13, logx=True, logy=True, marker='o')
        plt.xlabel("horizon", fontsize=13, fontweight="bold")
        plt.ylabel("regret", fontsize=13, fontweight="bold")
        plt.title(l[i][0].replace('-', ''), fontsize=16, fontweight="bold")
        plt.legend(loc="best", fontsize=15)
        plt.savefig(l[i][0].replace('-', '') + ".png", bbox_inches='tight')
